﻿Public Class Form1
    ' The current value.
    Private SliderValue As Single = 0.3

    ' The minimum and maximum allowed values.
    Private Const MinimumValue As Single = 0.0
    Private Const MaximumValue As Single = 1.0

    ' Move the needle to this position.
    Private MouseIsDown As Boolean = False
    Private Sub picSlider_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picSlider.MouseDown
        MouseIsDown = True
        SetValue(XtoValue(e.X))
    End Sub

    Private Sub picSlider_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picSlider.MouseMove
        If (Not MouseIsDown) Then Return
        SetValue(XtoValue(e.X))
    End Sub

    Private Sub picSlider_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picSlider.MouseUp
        MouseIsDown = False
        tipValue.Hide(Me)

        ' Take action here if desired.
        lblResult.Text = SliderValue.ToString("0.00")
    End Sub

    ' Convert an X coordinate to a value.
    Private Function XtoValue(ByVal x As Integer) As Single
        Return MinimumValue + (MaximumValue - MinimumValue) * _
            x / CSng(picSlider.ClientSize.Width - 1)
    End Function

    ' Convert value to an X coordinate.
    Private Function ValueToX(ByVal value As Single) As Single
        Return (picSlider.ClientSize.Width - 1) * _
            (value - MinimumValue) / CSng(MaximumValue - MinimumValue)
    End Function

    ' Draw the needle.
    Private Sub picSlider_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles picSlider.Paint
        ' Calculate the needle's X coordinate.
        Dim x As Single = ValueToX(SliderValue)

        ' Draw it.
        e.Graphics.DrawLine(Pens.Blue, _
            x, 0, _
            x, picSlider.ClientSize.Height)
    End Sub

    ' Set the slider's value. If the value has changed,
    ' display the value tooltip.
    Private Sub SetValue(ByVal value As Single)
        ' Make sure the new value is within bounds.
        If (value < MinimumValue) Then value = MinimumValue
        If (value > MaximumValue) Then value = MaximumValue

        ' See if the value has changed.
        If (SliderValue = value) Then Return

        ' Save the new value.
        SliderValue = value

        ' Redraw to show the new value.
        picSlider.Refresh()

        ' Display the value tooltip.
        Dim tip_x As Integer = picSlider.Left + CInt(ValueToX(SliderValue))
        Dim tip_y As Integer = picSlider.Top
        tipValue.Show(SliderValue.ToString("0.00"), Me, tip_x, tip_y, 3000)

        ' Take action here if desired.
        lblResult.Text = SliderValue.ToString("0.00")
    End Sub
End Class
